--
-- c_water.lua
--
myWaterShader = nil
local isSunEnabled = true

addEventHandler( "onClientResourceStart", getResourceRootElement( getThisResource()),
	function()

		-- Version check
		if getVersion ().sortable < "1.1.3" then
			outputChatBox( "Resource is not compatible with this client." )
			return
		end

		-- Create shader
		myWaterShader, tec = dxCreateShader ( "water.fx",0,0,false )

		if not myWaterShader then
			outputChatBox( "Could not create shader. Please use debugscript 3" )
		else
			outputConsole( "Shader Water2: using technique " .. tec )
			if isSunEnabled then enableSunLight() end

			-- Set textures
			local textureVol = dxCreateTexture ( "images/wavemap.png" );
			local textureCube = dxCreateTexture ( "images/cube_env256.dds" );
			dxSetShaderValue ( myWaterShader, "sRandomTexture", textureVol );
			dxSetShaderValue ( myWaterShader, "sReflectionTexture", textureCube );

			-- Apply to global txd 13
			engineApplyShaderToWorldTexture ( myWaterShader, "waterclear256" ) 

			-- Update water color incase it gets changed by persons unknown
			setTimer(	function()
							if myWaterShader then
								local r,g,b,a = getWaterColor()
								dxSetShaderValue ( myWaterShader, "sWaterColor", r/255, g/255, b/255, a/255 );
								local rSkyTop,gSkyTop,bSkyTop,rSkyBott,gSkyBott,bSkyBott = getSkyGradient ()
								dxSetShaderValue ( myWaterShader, "sSkyColorTop", rSkyTop/255, gSkyTop/255, bSkyTop/255)
								dxSetShaderValue ( myWaterShader, "sSkyColorBott", rSkyBott/255, gSkyBott/255, bSkyBott/255)
								
							end
						end
						,100,0 )
		end
	end
)
